package net.rutles.mygesture;

import java.util.ArrayList;

import android.app.Activity;
import android.gesture.Gesture;
import android.gesture.GestureLibraries;
import android.gesture.GestureLibrary;
import android.gesture.GestureOverlayView;
import android.gesture.GestureOverlayView.OnGesturePerformedListener;
import android.gesture.Prediction;
import android.os.Bundle;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.TextView;

public class MyGesture extends Activity 
	implements OnGesturePerformedListener{
	
	GestureLibrary gestureLibrary;
	EditText editText;
	RadioButton radioButton;
	TextView textView;
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		//gestureLibrary = GestureLibraries.fromFile(Environment.getExternalStorageDirectory().getPath()+"/gestures");
		gestureLibrary = GestureLibraries.fromPrivateFile(this,"gestures");
		gestureLibrary.load();

		GestureOverlayView gestureOverlayView = (GestureOverlayView) findViewById(R.id.GestureOverlayView01);
		gestureOverlayView.addOnGesturePerformedListener(this);
		
		editText = (EditText) findViewById(R.id.EditText01);
		radioButton = (RadioButton) findViewById(R.id.RadioButton01);
		radioButton.setChecked(true);
		textView = (TextView) findViewById(R.id.TextView01);
	}
	
	@Override
	public void onGesturePerformed(GestureOverlayView arg0, Gesture arg1) {
		// TODO Auto-generated method stub
		if(radioButton.isChecked()){
			String name = editText.getText().toString();
			if(name.length() > 0){
				gestureLibrary.addGesture(name, arg1);
				gestureLibrary.save();

				textView.setText(name + getString(R.string.message));
			}else{
				textView.setText(getString(R.string.error2));
			}
			return;
		}
		
		ArrayList<Prediction> predictions = gestureLibrary.recognize(arg1);
		
		if (predictions.size() > 0) {
			StringBuffer stringBuffer = new StringBuffer();
				for(Prediction prediction : predictions){
				
				stringBuffer
				.append(prediction.name)
				.append("-")
				.append(prediction.score)
				.append("\n");
			}
			textView.setText(stringBuffer);
		} else {
			textView.setText(getString(R.string.error1));
		}
	}
}